export interface PageQueryParams {
  current?: number;
  page?: number;
  pageSize?: number;
  sort?: string;
  timestamp?: string;
  _export_scope_?: string;
  _export_type_?: string;
  total?: number;
}

export interface Sort {
  property: string;
  direction: 'asc' | 'desc';
}

export interface Resp {
  readonly timestamp?: string;
  readonly bizcode?: number;
  readonly code?: number;
  readonly flag?: boolean;
  readonly path?: string;
  readonly msg?: string;
  readonly query?: string;
  readonly status?: string;
  readonly extras?: Record<string, any>;
}

export interface RespPageResultSuper {
  current: number;
  page: number;
  pageSize: number;
  total: number;
  hasNextPage: boolean;
  hasPrevPage: boolean;
  totalPageNum: number;
}

export interface RespPageResult<T>
  extends RespPageResultSuper,
    RespListResult<T> {
  data: T[];
}

export interface RespListResult<T> extends Resp {
  data: T[];
}

export interface RespResult<T> extends Resp {
  data: T;
}

export const createRespResult = (data: any): RespResult<any> => {
  return { flag: true, data };
};
export const createRespResultPromise = (
  data: any,
): Promise<RespResult<any>> => {
  return new Promise((resolve) => resolve(createRespResult(data)));
};
