import React, { useEffect } from "react";
import "./main.less";
import "../assets/iconfont/iconfont";
import { history, useModel } from "umi";
import config from "@/api/config";
import { getToken, getUserinfo } from "@/api";

const Main = () => {
  useEffect(() => {
    if (!window.location.search) {
    }
  }, []);
  const { loginInfo, user, setUser, setLoginInfo } = useModel("global");

  useEffect(() => {
    try {
      /** 不存在先直接跳转 */
      if (!loginInfo?.token && !window.location.search) {
        window.location.href = `${config.thirdPartyFrontEndPageUrl}/authorizedLogin.html?client_id=OM90JPKW&response_type=code&redirect_uri=${config.devAppUrl}`;
        return;
      }

      if (!loginInfo?.token && window.location.search) {
        const params = new URLSearchParams(window.location.search);

        if (params.get("code")) {
          getToken(params.get("code") as string)
            .then((res) => {
              setLoginInfo(res.data);
            })
            .catch((err) => {
              alert(JSON.stringify(err));
            });
        }
      }
    } catch (error) {
      alert(error);
    }
  }, []);

  useEffect(() => {
    if (!user && loginInfo?.token) {
      getUserinfo(loginInfo?.openId, loginInfo?.token)
        .then((res) => {
          alert(JSON.stringify(res.data));
          setUser(res.data);
        })
        .catch((err) => {
          alert(JSON.stringify(err));
        });
    }
  }, [loginInfo, user]);

  return (
    <div className="main_container">
      <div
        className="card"
        onClick={() => {
          history.push("/report");
        }}
      >
        <div>
          <div className="main_card-title">我要上报</div>
          <div className="main_card-subtitle">城市问题随手拍</div>
        </div>
        <div>
          <svg
            className="icon"
            aria-hidden="true"
            style={{ width: "48px", height: "48px" }}
          >
            <use xlinkHref="#icon-shangbao"></use>
          </svg>
        </div>
      </div>
      <div
        className="card"
        onClick={() => {
          history.push("/historyList");
        }}
      >
        <div>
          <div className="main_card-title">我的上报</div>
          <div className="main_card-subtitle">查看我上报的案件</div>
        </div>
        <div>
          <svg
            className="icon"
            aria-hidden="true"
            style={{ width: "48px", height: "48px" }}
          >
            <use xlinkHref="#icon-qingxijilu"></use>
          </svg>
        </div>
      </div>
    </div>
  );
};

export default Main;
